"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * SonarTS
 * Copyright (C) 2017-2019 SonarSource SA
 * mailto:info AT sonarsource DOT com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
const ts = require("typescript");
function isAny(type) {
    return Boolean(type.flags & ts.TypeFlags.Any);
}
exports.isAny = isAny;
function isUnion(type) {
    return Boolean(type.flags & ts.TypeFlags.Union);
}
exports.isUnion = isUnion;
function isArray(node, typeChecker) {
    const type = typeChecker.getTypeAtLocation(node);
    return !!type.symbol && type.symbol.name === "Array";
}
exports.isArray = isArray;
function isNullType(type) {
    return Boolean(type.flags & ts.TypeFlags.Null);
}
exports.isNullType = isNullType;
function isUndefinedType(type) {
    return Boolean(type.flags & ts.TypeFlags.Undefined);
}
exports.isUndefinedType = isUndefinedType;
function isVoidType(type) {
    return Boolean(type.flags & ts.TypeFlags.Void);
}
exports.isVoidType = isVoidType;
exports.ARRAY_MUTATING_CALLS = ["reverse", "sort"];
//# sourceMappingURL=semantics.js.map